#!/usr/bin/php
<?php

set_time_limit(0);

require 'config.php';

require_once 'inc/shell_colors.php';
$colors = new Colors();

require_once YOUR_WP_DIR . '/wp-load.php';

$posts = $wpdb->get_results("SELECT $wpdb->posts.* FROM $wpdb->posts WHERE $wpdb->posts.post_status = 'publish' AND ($wpdb->posts.post_type = 'post' OR $wpdb->posts.post_type = 'page')");

foreach($posts as $my_post) {
    preg_match_all('#<img.*src="(?<src>[^"]+)"#Um', $my_post->post_content, $images);
    
    if (!$num_images = count($images['src'])) {
        continue;
    }
    
    $this_post = array();
    $this_post['ID'] = $my_post->ID;
    $this_post['post_content'] = $my_post->post_content;
    
    for($i = 0; $i < $num_images; $i++) {
        $src = $images['src'][$i];
        
        // If it doesn't start with our prefix, skip it
        if (strpos($src, SQUARESPACE_PREFIX) !== 0)
            continue;
        
        $attachment = $wpdb->get_row("SELECT $wpdb->posts.* FROM $wpdb->posts WHERE guid LIKE concat('%', '{$wpdb->escape($src)}')");
        
        if (!$attachment || strpos($attachment->post_mime_type, 'image') === FALSE) {
            // we only want image attachments
            continue;
        }
        
        if ($i == 0) {
            // set first attachment to featured post image
            update_post_meta($my_post->ID, '_thumbnail_id', $attachment->ID);
            echo 'Post: ' . $my_post->ID . ' Attachment: ' . $attachment->ID . ' ' . $colors->getColoredString('FEATURED IMAGE SET', 'green') . "\n";
        }
        
        $attachment_url = wp_get_attachment_url($attachment->ID);
        
        // attach image to post
        wp_insert_attachment(array('ID' => $attachment->ID), false, $my_post->ID);
        echo 'Post: ' . $my_post->ID . ' Attachment: ' . $attachment->ID . ' ' . $colors->getColoredString('ATTACHED', 'green') . ' ' . $colors->getColoredString($attachment_url, 'light_gray') . "\n";
        
        // update post content
        $this_post['post_content'] = str_replace($src, $attachment_url, $this_post['post_content']);
    }
    
    // Update the post into the database
    wp_update_post($this_post);
}
